#!/usr/bin/env python
# ======================================================================
# Copyright (C) 2010 and onwards Robert Muth <robert at muth dot org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 3
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# ======================================================================

"""
config helper
"""

import imp
import sys
import templates

class _datablob:
  def __init__(self, **args):
    self.__dict__.update(args)




_config = _datablob()

_topics = []

_module = None


def LoadConfig(fname):
    global _module
    try:
        desc =  ('.py', 'U', 1)
        _module = imp.load_module("config", open(fname), fname, desc)
    except Exception, e:
        logging.error("error loading config: %s", e)
        # TODO: systemExit not defined
        raise sys.exit(-1)


def Reload():
    global _module
    logging.info("reloading config")
    _module = reload(_module)


def GetConfig():
    return _config


def GetTopics():
    return _topics


def GetConfigTopic(topic):
    global _config
    global _topics
    d = _config.__dict__
    if topic not in d:
        d[topic] = _datablob()
        _topics.append(topic)
    return  d[topic]
######################################################################
##
######################################################################
def HandlerConfig(request, path, args, config, settings):
    template = templates.GetTemplate("config.ezt")

    request.send_response(200)
    request.send_header("Content-Type", 'text/html')
    request.end_headers()

    def RenderClassFields(o):
      return [ _datablob(tag=k, val=str(o.__dict__[k]))
               for k in o.__dict__
               if not k.startswith("_")]


    data = {}
    for topic in GetTopics():
      data[topic] =  RenderClassFields(GetConfigTopic(topic))

    template.generate(request.wfile, data)
    return

