#!/usr/bin/env python
# ======================================================================
# Copyright (C) 2008 and onwards Robert Muth <robert at muth dot org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 3
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# ======================================================================

import os
import logging

import ezt
######################################################################
##
######################################################################
CACHE = {}
CACHE_DIR = ""
ENCODINGS = None

######################################################################
##
######################################################################
def Init(config):
    global CACHE_DIR
    global ENCODINGS
    CACHE_DIR = config.path
    ENCODINGS = config.encodings

def GetTemplate(name):
    global CACHE
    global CACHE_DIR
    global ENCODINGS
    if name not in CACHE:
        full_path = os.path.join(CACHE_DIR, name)
        logging.info("loading template [%s]", full_path)

        CACHE[name] = ezt.Template(full_path, ENCODINGS)

    return CACHE[name]

