#!/usr/bin/env python
# ======================================================================
# Copyright (C) 2010 and onward Robert Muth <robert @ muth dot org>.
# All Rights Reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 3
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# ======================================================================

# python imports
import unittest
import logging

#local import
import playlist


INPUT_M3U_IN = "testdata/1.m3u"

class TestM3uReadWrite(unittest.TestCase):

    def setUp(self):
        self.test_m3u = open(INPUT_M3U_IN).read()

    def testM3uReadWrite(self):
        pl = playlist.Playlist()
        m3u_parser = playlist.M3uParser()

        m3u_parser.Parse(self.test_m3u.split("\n"), pl)
        out = pl.MakeM3u(1, 0)
        for line1, line2 in zip(out.split("\n"), self.test_m3u.split("\n")):
            self.assertEqual(line1, line2)

    def testXspfReadWrite(self):
        pl = playlist.Playlist()
        m3u_parser = playlist.M3uParser()
        m3u_parser.Parse(self.test_m3u.split("\n"), pl)

        out = pl.MakeXspf(1)

        pl2 = playlist.Playlist()
        xspf_parser = playlist.XspfParser()
        xspf_parser.Parse(out, pl2)

        self.assertTrue(pl.IsEqual(pl2))
        #print pl.MakeXspf(1)
        #print pl.MakeXspf(1)

if __name__ == '__main__':
    unittest.main()

